var keys = ["Alarm", "Fire", "Potentially Life-Threatening", "Non Life-Threatening"]
var year = ["2012", "2013", "2014", "2015", "2016", "2017", "2018", "2019"]
var neighborhoods = ["Bayview Hunters Point","Bernal Heights","Castro/Upper Market","Chinatown,Excelsior","Financial District/South Beach","Glen Park","Golden Gate Park","Haight Ashbury","Hayes Valley","Inner Richmond","Inner Sunset","Japantown","Lakeshore","Lincoln Park","Lone Mountain/USF,Marina","McLaren Park","Mission","Mission Bay","Nob Hill","Noe Valley","North Beach","Oceanview/Merced/Ingleside","Outer Mission","Outer Richmond","Pacific Heights","Portola","Potrero Hill","Presidio","Presidio Heights","Russian Hill","Seacliff","South of Market","Sunset/Parkside","Tenderloin","Treasure Island","Twin Peaks","Visitacion Valley","West of Twin Peaks","Western Addition"]


var svg = d3.select("#chart"),
	margin = {top: 35, left: 35, bottom: 75, right: 0},
	width = +svg.attr("width") - margin.left - margin.right,
	height = +svg.attr("height") - margin.top - margin.bottom;

var x = d3.scaleBand()
	.range([margin.left, width - margin.right])
	.padding(0.1)

var y = d3.scaleLinear()
	.rangeRound([height - margin.bottom, margin.top])

var xAxis = svg.append("g")
	.attr("transform", `translate(0,${height - margin.bottom})`)
	.attr("class", "x-axis")

var yAxis = svg.append("g")
	.attr("transform", `translate(${margin.left},0)`)
	.attr("class", "y-axis")

var z = d3.scaleOrdinal()
	.range(["yellow", "orangered", "crimson", "darkred"])
	.domain(keys);

/*update(d3.select(#year).property("value"),0)

function update(input, speed) {
	var newData = csv.filter(f => f.Year == input)

	data.forEach(function(d){
		d.total = d3.sum(types, t => +d[t])
		return d
	})
}*/

x.domain(neighborhoods);

svg.selectAll(".x-axis").transition().duration(0)
	.call(d3.axisBottom(x).tickSizeOuter(0))

//draw rotate text
svg.selectAll(".x-axis text") 
    .style("text-anchor", "end")
        .attr("dx", "-.8em")
        .attr("dy", "-.7em")
        .attr("transform", function(d) {
            return "rotate(-90)"
});


//change dropdown option
var select = d3.select("#year")
	.on("change", function() {
		update(this.value, 750)
	})

//change sorting checkbox
var checkbox = d3.select("#sort")
	.on("click", function() {
		update(select.property("value"), 750)
	})




var outerWidth = 900;
      var outerHeight = 650;
      //var margin = { left: 90, top: 30, right: 30, bottom: 40 };
      var barPadding = 0.2;

      var xColumn = "Neighborhoods";
      var yColumn = "Avg";
      var colorColumn = "Group";
      var layerColumn = colorColumn;

      var innerWidth  = outerWidth  - margin.left - margin.right;
      var innerHeight = outerHeight - margin.top  - margin.bottom;

function drawBars(data){

	var nested = d3.nest()
		.key(function (d) {return d[layerColumn];})
		.entries(data);

	var stack = d3.layout.stack()
		.y(function (d) { return d[yColumn]; })
		.values(function (d) { return d.values; });

	var layers = stack(nested);

	xScale.domain(layers[0].values.map(function (d){
          return d[xColumn];
        }));

        yScale.domain([
          0,
          d3.max(layers, function (layer){
            return d3.max(layer.values, function (d){
              return d.y0 + d.y;
            });
          })
        ]);

     var layers = g.selectAll(".layer").data(layers);
        layers.enter().append("g").attr("class", "layer");
        layers.exit().remove();
        layers.style("fill", function (d){
          return colorScale(d.key);
        }); 

        var bars = layers.selectAll("rect").data(function (d){
          return d.values;
        });
        bars.enter().append("rect")
        bars.exit().remove();
        bars
          .attr("x", function (d){ return xScale(d[xColumn]); })
          .attr("y", function (d){ return yScale(d.y0 + d.y); })
          .attr("width", xScale.rangeBand())
          .attr("height", function (d){ return innerHeight - yScale(d.y); })


	/*data.forEach(function(d){
		d.total = d3.sum(keys, t => +d[t])
		return d
	})

	svg.selectAll("bar")
      .data(data)
    .enter().append("rect")
      .style("fill", "steelblue")
      .attr("x", function(d) { return x(d.Neighborhoods); })
      .attr("width", x.rangeBand())
      .attr("y", function(d) { return y(d.Avg); })
      .attr("height", function(d) { return height - y(d.Avg); });*/
	
}

function type(d) {
	d.Avg = +d.Avg
	return d;
}


d3.csv("data/Response_Data.csv").then(function(data){
	var currData = data.filter(d => d.Year === "2019");
	console.log(currData);
	
	type(currData)
	drawBars(currData)
});

